PrefabFiles = {
    "z_gates",
}

Assets = {
--    Asset( "ANIM", "anim/bow_attack.zip" ),
--	Asset("SOUNDPACKAGE", "sound/bow_shoot.fev"),
--    Asset("SOUND", "sound/bow_shoot_bank00.fsb"),
--	
--	Asset("ATLAS", "images/tabimages/archery_tab.xml"),
--    Asset("IMAGE", "images/tabimages/archery_tab.tex"),
}

local require = GLOBAL.require

local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local GIngredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH

local FRAMES = GLOBAL.FRAMES
local ACTIONS = GLOBAL.ACTIONS
local State = GLOBAL.State
local EventHandler = GLOBAL.EventHandler
local ActionHandler = GLOBAL.ActionHandler
local TimeEvent = GLOBAL.TimeEvent
local EQUIPSLOTS = GLOBAL.EQUIPSLOTS


local WOODGATEBOARDREQ = GetModConfigData("WoodGateBoards_req")
local WOODGATEROPEREQ = GetModConfigData("WoodGateRope_req")
local WOODGATEHAMMERREQ = GetModConfigData("WoodGateHammer_req")
local WOODGATETOOTHREQ = GetModConfigData("WoodGateTooth_req")
local WOODGATESTINGERREQ = GetModConfigData("WoodGateStinger_req")
local WOODGATETECHLEVEL = GetModConfigData("WoodGateTechLevel")

----------------------------------------------------------------------------------------------------------------------------

local function ReturnTechLevel(modcfg)
	if modcfg == "NONE" then
		return TECH.NONE
	elseif modcfg == "SCIENCE_ONE" then
		return TECH.SCIENCE_ONE
	elseif modcfg == "SCIENCE_TWO" then
		return TECH.SCIENCE_TWO		
	elseif modcfg == "MAGIC_TWO" then
		return TECH.MAGIC_TWO			
	elseif modcfg == "MAGIC_THREE" then
		return TECH.MAGIC_THREE			
	end
end

local WOODGATErecipeIngredients = {}

WOODGATErecipeIngredients[#WOODGATErecipeIngredients + 1]= GIngredient("boards", WOODGATEBOARDREQ);

if WOODGATEROPEREQ > 0 then
	WOODGATErecipeIngredients[#WOODGATErecipeIngredients + 1] = GIngredient("rope", WOODGATEROPEREQ);
end

if WOODGATEHAMMERREQ > 0 then
	WOODGATErecipeIngredients[#WOODGATErecipeIngredients + 1] = GIngredient("hammer", WOODGATEHAMMERREQ);
end

if WOODGATETOOTHREQ > 0 then
	WOODGATErecipeIngredients[#WOODGATErecipeIngredients + 1] = GIngredient("houndstooth", WOODGATETOOTHREQ);
end

if WOODGATESTINGERREQ > 0 then
	WOODGATErecipeIngredients[#WOODGATErecipeIngredients + 1] = GIngredient("stinger", WOODGATESTINGERREQ);
end

AddRecipe("woodgate_item", WOODGATErecipeIngredients , GLOBAL.RECIPETABS.TOWN, ReturnTechLevel(WOODGATETECHLEVEL), nil, nil, nil, 1, nil, "images/inventoryimages/woodgate_item.xml", "woodgate_item.tex")

--------------------------------------------------------------------------------------------------------------------------------------

STRINGS.NAMES.WOODGATE_ITEM = "Wooden Gate"
STRINGS.RECIPE_DESC.WOODGATE_ITEM = "Keep intruders out."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WOODGATE_ITEM = "Am I supposed to mount it myslef?"

STRINGS.NAMES.WOODGATE = "Wooden Gate"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WOODGATE = "This doesn't look very strong..."

local OPENGATE = GLOBAL.Action(	6,		-- priority
								nil,	-- instant (set to not instant)
								false,	-- right mouse button
								nil,	-- distance check
								nil,	-- ghost valid (set to not ghost valid)
								nil,	-- ghost exclusive
								nil,	-- can force action
								nil)	-- Range check function
OPENGATE.str = "Open"
OPENGATE.id = "OPENGATE"
OPENGATE.fn = function(act)
	gate = act.target
	
	gate.components.zupalexsgates:Open()

	return true
end

AddAction(OPENGATE)

local CLOSEGATE = GLOBAL.Action( 6,		-- priority
								nil,	-- instant (set to not instant)
								false,	-- right mouse button
								nil,		-- distance check
								nil,	-- ghost valid (set to not ghost valid)
								nil,	-- ghost exclusive
								nil,	-- can force action
								nil)	-- Range check function
CLOSEGATE.str = "Close"
CLOSEGATE.id = "CLOSEGATE"
CLOSEGATE.fn = function(act)
	gate = act.target
	
	gate.components.zupalexsgates:Close()

	return true
end

AddAction(CLOSEGATE)

local PLACEGATE = GLOBAL.Action( 6,		-- priority
								nil,	-- instant (set to not instant)
								false,	-- right mouse button
								nil,		-- distance check
								nil,	-- ghost valid (set to not ghost valid)
								nil,	-- ghost exclusive
								nil,	-- can force action
								nil)	-- Range check function
PLACEGATE.str = "Place Gate"
PLACEGATE.id = "PLACEGATE"
PLACEGATE.fn = function(act)
    if act.invobject and act.invobject.components.deployable and act.invobject.components.deployable:CanDeploy(act.pos) then
        local obj = (act.doer.components.inventory and act.doer.components.inventory:RemoveItem(act.invobject)) or 
        (act.doer.components.container and act.doer.components.container:RemoveItem(act.invobject))
        if obj then
            if obj.components.deployable:Deploy(act.pos, act.doer) then
                return true
            else
                act.doer.components.inventory:GiveItem(obj)
            end
        end
    end
end

AddAction(PLACEGATE)

AddStategraphActionHandler("wilson", ActionHandler(OPENGATE, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(CLOSEGATE, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(PLACEGATE, "doshortaction"))

AddStategraphActionHandler("wilson_client", ActionHandler(OPENGATE, "doshortaction"))
AddStategraphActionHandler("wilson_client", ActionHandler(CLOSEGATE, "doshortaction"))
AddStategraphActionHandler("wilson_client", ActionHandler(PLACEGATE, "doshortaction"))

local function scene_gates(inst, doer, actions, right)
	if inst:HasTag("wall") and inst:HasTag("gate") then
		if inst:HasTag("open") then
			table.insert(actions, CLOSEGATE)
		elseif inst:HasTag("closed" )then
			table.insert(actions, OPENGATE)
		end
	end
end 

local function point_gates(inst, doer, pos, actions, right)
    if right and inst.replica.inventoryitem ~= nil and inst.replica.inventoryitem:CanDeploy(pos) then
        table.insert(actions, PLACEGATE)
    end
end
	
AddComponentAction("SCENE", "zupalexsgates", scene_gates)
AddComponentAction("POINT", "zupalexsgates", point_gates)
