local function ononcooldown(self, oncooldown)
    if oncooldown then
        self.inst:AddTag("cooldown")
    else
        self.inst:RemoveTag("cooldown")
    end
end

local Zupalexsgates = Class(function(self, inst)
	self.inst = inst
	self.openfn = nil
	self.closefn = nil
    self.isopen = false
	self.cooldowntime = 1
    self.oncooldown = false
end,
nil,
{
    oncooldown = ononcooldown,
})

function Zupalexsgates:OnRemoveFromEntity()
    self.inst:RemoveTag("turnedon")
    self.inst:RemoveTag("cooldown")
end

function Zupalexsgates:OnSave()
	local data = {}	
	data.isopen = self.isopen
	data.facingoffset = self.facingoffset
	return data
end

function Zupalexsgates:OnLoad(data)
	if data then
		self.isopen = data.isopen
		if self:IsOpen() then self:Open() else self:Close() end
	end
end

function Zupalexsgates:Open()
	if self.cooldowntime > 0 then 
		self.oncooldown = true
		self.inst:DoTaskInTime(self.cooldowntime, function() self.oncooldown = false end)
	end

	if not self.inst:HasTag("open") then
		self.inst:AddTag("open")
	end
	if self.inst:HasTag("closed") then
		self.inst:RemoveTag("closed")
	end
	
	if self.openfn then
		self.openfn(self.inst)
	end
	self.isopen = true
end

function Zupalexsgates:CanInteract()
    return
        not (self.inst.replica.equippable ~= nil and
            not self.inst.replica.equippable:IsEquipped() and
            self.inst.replica.inventoryitem ~= nil and
            self.inst.replica.inventoryitem:IsHeld())
end

function Zupalexsgates:Close()
	if self.inst:HasTag("open") then
		self.inst:RemoveTag("open")
	end
	if not self.inst:HasTag("closed") then
		self.inst:AddTag("closed")
	end

	if self.cooldowntime > 0 then 
		self.oncooldown = true
		self.inst:DoTaskInTime(self.cooldowntime, function() self.oncooldown = false end)
	end

	if self.closefn then
		self.closefn(self.inst)
	end
	self.isopen = false
end

function Zupalexsgates:IsOpen()
	return self.isopen
end

return Zupalexsgates