local assets=
{
    Asset("ANIM", "anim/gates.zip"),

    Asset("ATLAS", "images/inventoryimages/woodgate_item.xml"),
    Asset("IMAGE", "images/inventoryimages/woodgate_item.tex"),
}
prefabs = {
}

-------------------------------------------------------------GATES--------------------------------------------------------

require "prefabutil"

local function onhammered(inst, worker)
    inst.components.lootdropper:SpawnLootPrefab("woodgate_item")

    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")

    inst:Remove()
end

local function OnFriendWallDestroyed(inst)
--	print("I entered the OnFriendWallDestroyed function")
	if inst.friendgate ~= nil then
		otherfriend:RemoveEventCallback("onremove")
		inst.friendgate.components.lootdropper:SpawnLootPrefab("woodgate_item")

		inst.friendgate.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")

		inst.friendgate:Remove()
	end
end

local musttags = { "wall" }
local canttags = { "gate" }

local function InitializeTrackCameraRotation(inst)
--	print("Initialization the facing offset for ", inst)
	local cameraangle = TheCamera:GetHeading()
	inst.tempfacingoffset = nil
	inst.currentfacing = (cameraangle%45 == 0 and cameraangle) or nil
	inst._clientfacing = nil
	inst.friendwalls = {}

	local gate_x, gate_y, gate_z = inst.Transform:GetWorldPosition()
	
	local nearbywalls = TheSim:FindEntities(gate_x, gate_y, gate_z, 2, musttags, canttags, nil)

	local matchfound = false
	
	if #nearbywalls > 1 then
		for k1, v1 in pairs(nearbywalls) do
			for k2, v2 in pairs(nearbywalls) do
				if k1 ~= k2 then
					local wall1_x, wall1_y, wall1_z = v1.Transform:GetWorldPosition()
					local wall2_x, wall2_y, wall2_z = v2.Transform:GetWorldPosition()
										
--					print("Found a pair of walls nearby : ")
--					print("wall1 : ", v1, "(", wall1_x, " , ", wall1_y, " , ", wall1_z, ")")
--					print("wall2 : ", v2, "(", wall2_x, " , ", wall2_y, " , ", wall2_z, ")")
					if math.abs(wall1_x - wall2_x) == 2 and math.abs(wall1_z - wall2_z) == 2 then		
--						print("Found a Match!")
						if (wall1_x - wall2_x < 0 and wall1_z - wall2_z < 0) or (wall1_x - wall2_x > 0 and wall1_z - wall2_z > 0) then
							inst.tempfacingoffset = -45
						elseif (wall1_x - wall2_x < 0 and wall1_z - wall2_z > 0) or (wall1_x - wall2_x > 0 and wall1_z - wall2_z < 0) then
							inst.tempfacingoffset = 45
						end
						
						matchfound = true
						table.insert(inst.friendwalls, v1)
						table.insert(inst.friendwalls, v2)
						
						break
							
					elseif math.abs(wall1_x - wall2_x) == 3 then
--						print("Found a Match!")
						inst.tempfacingoffset = 0
						matchfound = true
						
						table.insert(inst.friendwalls, v1)
						table.insert(inst.friendwalls, v2)
						
						break	
						
					elseif math.abs(wall1_z - wall2_z) == 3 then
--						print("Found a Match!")
						inst.tempfacingoffset = 90
						matchfound = true
				
						table.insert(inst.friendwalls, v1)
						table.insert(inst.friendwalls, v2)
						
						break	
						
					end
				end
			end	
			if matchfound then break end			
		end
	end
	
	if inst.currentfacing ~= nil and inst.tempfacingoffset ~= nil then
		inst.snapangle = inst.currentfacing
		if cameraangle%45 == 0 then
			inst.currentfacing = cameraangle
			inst.updatefacing = true
			
			local finalfacing = inst.currentfacing+inst.tempfacingoffset
			if finalfacing < 0 then
				finalfacing = finalfacing + 360
			elseif finalfacing >= 360 then
				finalfacing = finalfacing - 360
			end		
			
			inst.AnimState:PlayAnimation("placed_"..finalfacing)
		
			if TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
				inst._hostfacing:set(inst.currentfacing)
			end
		end
		
--		print("Friend Walls :")
--		for k, v in pairs(friendwalls) do
--			print(k, "  /  ", v, "  -> Friend Gate = ", v.friendgate)
--		end
	end
end

local function TrackCameraRot(inst)	
	local cameraangle = TheCamera:GetHeading()
	
	if inst.tempfacingoffset == nil or inst.currentfacing == nil or inst.snapangle == nil then
		InitializeTrackCameraRotation(inst)
		return
	end
	
	if math.abs(cameraangle - inst.snapangle) >= 45 then
		inst.snapangle = cameraangle
		inst.updatefacing = true
	end
	
	if cameraangle%45 == 0 then
		inst.snapangle = cameraangle
		
		if cameraangle ~= inst.currentfacing then
			inst.currentfacing = (cameraangle ~= 360 and cameraangle) or 0
			local finalfacing = inst.currentfacing+inst.tempfacingoffset
			if finalfacing < 0 then
				finalfacing = finalfacing + 360
			elseif finalfacing >= 360 then
				finalfacing = finalfacing - 360
			end		
			
			if TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
				inst._hostfacing:set(inst.currentfacing)
			end
			
			inst.AnimState:PlayAnimation("placed_"..finalfacing)
			inst.updatefacing = true
		end
	end
	
	if inst.currentfacing == 0 and cameraangle > 315 and inst.updatefacing then
		inst.updatefacing = false
		inst.currentfacing = 315
		
		local finalfacing = inst.currentfacing+inst.tempfacingoffset
		if finalfacing < 0 then
			finalfacing = finalfacing + 360
		elseif finalfacing >= 360 then
			finalfacing = finalfacing - 360
		end	
		
		inst.AnimState:PlayAnimation("placed_"..finalfacing)
		
		if TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
			inst._hostfacing:set(inst.currentfacing)
		end
		
	elseif inst.currentfacing == 360 and cameraangle < 45 and inst.updatefacing then
		inst.updatefacing = false
		inst.currentfacing = 45
		
		local finalfacing = inst.currentfacing+inst.tempfacingoffset
		if finalfacing < 0 then
			finalfacing = finalfacing + 360
		elseif finalfacing >= 360 then
			finalfacing = finalfacing - 360
		end	
				
		inst.AnimState:PlayAnimation("placed_"..finalfacing)	
		
		if  TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
			inst._hostfacing:set(inst.currentfacing)
		end
		
	elseif inst.currentfacing < cameraangle and inst.updatefacing then		
		inst.updatefacing = false
		inst.currentfacing = inst.currentfacing + 45
		
		local finalfacing = inst.currentfacing+inst.tempfacingoffset
		if finalfacing < 0 then
			finalfacing = finalfacing + 360
		elseif finalfacing >= 360 then
			finalfacing = finalfacing - 360
		end	
		
		inst.AnimState:PlayAnimation("placed_"..finalfacing)
	
		if TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
			inst._hostfacing:set(inst.currentfacing)
		end
		
	elseif inst.currentfacing > cameraangle and inst.updatefacing then
		inst.updatefacing = false
		inst.currentfacing = inst.currentfacing - 45
		
		local finalfacing = inst.currentfacing+inst.tempfacingoffset
		if finalfacing < 0 then
			finalfacing = finalfacing + 360
		elseif finalfacing >= 360 then
			finalfacing = finalfacing - 360
		end		
		
		inst.AnimState:PlayAnimation("placed_"..finalfacing)
		
		if TheWorld.ismastersim and inst._hostfacing:value() ~= inst.currentfacing then
			inst._hostfacing:set(inst.currentfacing)
		end
	end
	
	if inst.currentfacing == cameraangle and not inst.updatefacing then
		inst.updatefacing = true
	end

end

local function OnIsPathFindingDirty(inst)
    if inst._ispathfinding:value() then
        if inst._pfpos == nil then
            inst._pfpos = inst:GetPosition()
            TheWorld.Pathfinder:AddWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z)
			TheWorld.Pathfinder:AddWall(inst._pfpos.x+1, inst._pfpos.y, inst._pfpos.z)
			TheWorld.Pathfinder:AddWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z+1)
			TheWorld.Pathfinder:AddWall(inst._pfpos.x-1, inst._pfpos.y, inst._pfpos.z)
			TheWorld.Pathfinder:AddWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z-1)
        end
    elseif inst._pfpos ~= nil then
        TheWorld.Pathfinder:RemoveWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z)
		TheWorld.Pathfinder:RemoveWall(inst._pfpos.x+1, inst._pfpos.y, inst._pfpos.z)
		TheWorld.Pathfinder:RemoveWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z+1)
		TheWorld.Pathfinder:RemoveWall(inst._pfpos.x-1, inst._pfpos.y, inst._pfpos.z)
		TheWorld.Pathfinder:RemoveWall(inst._pfpos.x, inst._pfpos.y, inst._pfpos.z-1)
        inst._pfpos = nil
    end
end

local function InitializePathFinding(inst)
    inst:ListenForEvent("onispathfindingdirty", OnIsPathFindingDirty)
    OnIsPathFindingDirty(inst)
end

local function makeobstacle(inst)
    inst.Physics:SetActive(true)
    inst._ispathfinding:set(true)
end

local function clearobstacle(inst)
    inst.Physics:SetActive(false)
    inst._ispathfinding:set(false)
end

local function onremove(inst)
    inst._ispathfinding:set_local(false)
    OnIsPathFindingDirty(inst)
end

local function onhit(inst)
--	local animstateinfos = inst.AnimState
--	print("AnimState infos : ", animstateinfos)
--	local testmetatable = getmetatable(animstateinfos)
--	print("I can get the metatable : ", testmetatable)
--	for k, v in pairs(testmetatable) do
--		print(k, " /  ", v)
--	end
--	
--	print("------------ INDEX ------------------")
--	for k, v in pairs(testmetatable.__index) do
--		print(k, " /  ", v)
--	end
--	
--	print("Current Anim is Down : ", animstateinfos:IsCurrentAnimation("placed"))
--	print("Facing : ", animstateinfos:GetCurrentFacing())
--	print("Current Anim is : ", animstateinfos.name)
end

local function ondeploygate(inst, pt, deployer)
    local gate = SpawnPrefab("woodgate")
	
    if gate ~= nil then 	
		if inst.deployposx then
--			deployer.Physics:Teleport(inst.deployposx, 0, math.floor(pt.z) - 1)
			pt = Vector3(inst.deployposx, 0, math.floor(pt.z) + .5)
		elseif inst.deployposz then
--			deployer.Physics:Teleport(math.floor(pt.x) - 1, 0, inst.deployposz)
			pt = Vector3(math.floor(pt.x) + .5, 0, inst.deployposz)
		else
--			deployer.Physics:Teleport(math.floor(pt.x) - 1, 0, math.floor(pt.z) - 1)
			pt = Vector3(math.floor(pt.x) + .5, 0, math.floor(pt.z) + .5)
		end
		
        gate.Physics:SetCollides(false)
        gate.Physics:Teleport(pt:Get())
        gate.Physics:SetCollides(true)
        inst.components.stackable:Get():Remove()

        TheWorld.Pathfinder:AddWall(pt:Get())
    end
end

local function CanDeployZGates(self, pt, mouseover)
	local candeploywall = TheWorld.Map:CanDeployWallAtPoint(pt, self.inst)
	local candeploygate = false
	
	local ptposx, ptposy, ptposz = pt:Get()
	local nearbywalls = TheSim:FindEntities(ptposx, ptposy, ptposz, 2, musttags, nil, nil)
	
--	print("mouse position : ")
--	print(ptposx, "  /  ", ptposy, "  /  ", ptposz)
	
	if #nearbywalls > 1 then
		for k1, v1 in pairs(nearbywalls) do
			for k2, v2 in pairs(nearbywalls) do
				if k1 ~= k2 then
					local wall1_x, wall1_y, wall1_z = v1.Transform:GetWorldPosition()
					local wall2_x, wall2_y, wall2_z = v2.Transform:GetWorldPosition()
					
--					print("Found a pair of walls nearby : ")
--					print("wall1 : ", v1, "(", wall1_x, " , ", wall1_y, " , ", wall1_z, ")")
--					print("wall2 : ", v2, "(", wall2_x, " , ", wall2_y, " , ", wall2_z, ")")
					if math.abs(wall1_x - wall2_x) == 2 and math.abs(wall1_z - wall2_z) == 2 
					and math.abs(ptposx - wall1_x) <= 1.5 and math.abs(ptposx - wall2_x) <= 1.5 and math.abs(ptposz - wall1_z) <= 1.5 and math.abs(ptposz - wall2_z) <= 1.5 
						then
							candeploygate = true
							
							break
							
					elseif math.abs(wall1_x - wall2_x) == 3 then
						self.inst.deployposx = math.max(wall1_x, wall2_x) - 1.5
						candeploygate = true
						
						break	
						
					elseif math.abs(wall1_z - wall2_z) == 3 then
						self.inst.deployposz = math.max(wall1_z, wall2_z) - 1.5
						candeploygate = true
						
						break	
						
					end
					
--					print("----------------------------------------------------------------")
				end
			end			
		end
	end
	
	return (candeploywall and candeploygate)
end

local function OnHostChangeCanDeploy(inst)
--	print("I have to update the CanDeploy for the client")
	if inst._hostcandeploy:value() ~= inst._clientcandeploy then	
--		print("I should have now updated the CanDeploy for the client (previous = ", inst._clientcandeploy, ")")
		inst._clientcandeploy = inst._hostcandeploy:value()
--		print("New clientcandeploy value : ", inst._clientcandeploy)		
		inst.replica.inventoryitem.CanDeploy = CanDeployZGates
	end
end

local function woodgateitemfn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local netw = inst.entity:AddNetwork()
	
    MakeInventoryPhysics(inst)
     
    anim:SetBank("woodgate_closed")
    anim:SetBuild("gates")
    anim:PlayAnimation("idle")
 
	inst:AddTag("gate") -- Tag is not doing anything by itself. I can be called by other stuffs though.
	
 	inst._hostcandeploy = net_bool(inst.GUID, "_hostcandeploy", "onhostchangecandeploy")
	
 --The following section is suitable for a DST compatible prefab.
    inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then	
		inst._clientcandeploy = nil
		inst:ListenForEvent("onhostchangecandeploy", OnHostChangeCanDeploy)
        return inst
    end
	
----------------------------------------------------------------
	
    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM

    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "woodgate_item"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/woodgate_item.xml"

    inst:AddComponent("deployable")
	
	inst.components.deployable.CanDeploy = CanDeployZGates	
	
	if CanDeployZGates and not inst._hostcandeploy:value() then
--		print("I set the hostcandeploy to true")
		inst._hostcandeploy:set(true)
	end
	
    inst.components.deployable.ondeploy = ondeploygate
    inst.components.deployable:SetDeployMode(DEPLOYMODE.WALL)

	inst:AddComponent("zupalexsgates")
	
    MakeHauntableLaunch(inst)

	return inst
end

local function ListenForHostChangeFacing(inst)
	if TheCamera:GetHeading()%45 == 0 then
		if inst.tempfacingoffset == nil then
			inst:DoTaskInTime(0.5, function() ListenForHostChangeFacing(inst) end)
			return
		end
	
		local finalfacing = TheCamera:GetHeading()+inst.tempfacingoffset
		if finalfacing < 0 then
			finalfacing = finalfacing + 360
		elseif finalfacing >= 360 then
			finalfacing = finalfacing - 360
		end	
		
		if not inst.AnimState:IsCurrentAnimation("placed_"..finalfacing) then
			inst.AnimState:PlayAnimation("placed_"..finalfacing)
--			print("I should have now restored the client AnimState from ", inst._hostfacing:value(), " to ", TheCamera:GetHeading())
			if inst.LFHCG ~= nil then
				inst.LFHCG = nil
			end
		end
	end
end

local function OnHostChangeFacing(inst)
--	print("I have to restore the client AnimState")
	if not TheWorld.ismastersim then		
		if TheCamera:GetHeading() ~= inst._hostfacing:value() then

			
			if inst.LFHCG == nil then
				inst.LFHCF = inst:DoPeriodicTask(0, ListenForHostChangeFacing)
			end
		end
	end
end

local function onopenwoodgate(inst)
	inst.AnimState:SetBank("woodgate_open")
	clearobstacle(inst)
end

local function onclosewoodgate(inst)
	inst.AnimState:SetBank("woodgate_closed")
	makeobstacle(inst)
end

local function checkforfriendwalls(inst)
	if inst.friendwalls ~= nil then
--		print("Friend Walls :")
--		for k, v in pairs(inst.friendwalls) do
--			print(k, "  /  ", v)
--		end
		if #inst.friendwalls ~= 2 then
			onhammered(inst)
		else
			for k, v in pairs(inst.friendwalls) do
				if not v:IsValid() then
					onhammered(inst)
					break
				end
			end
		end
	end
end

local function woodgatedeployedfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.entity:AddAnimState()	
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

--    inst.Transform:SetEightFaced()

    MakeObstaclePhysics(inst, 0.8)
    inst.Physics:SetDontRemoveOnSleep(true)

    --inst.Transform:SetScale(1.3,1.3,1.3)

    inst:AddTag("wall")
    inst:AddTag("gate")	
	inst:AddTag("closed")

	inst.AnimState:SetBank("woodgate_closed")
	inst.AnimState:SetBuild("gates")
--	inst.AnimState:PlayAnimation("placed")
	
--    for i, v in ipairs(data.tags) do
--        inst:AddTag(v)
--    end

    MakeSnowCoveredPristine(inst)

    inst._pfpos = nil
    inst._ispathfinding = net_bool(inst.GUID, "_ispathfinding", "onispathfindingdirty")
    makeobstacle(inst)
    --Delay this because makeobstacle sets pathfinding on by default
    --but we don't to handle it until after our position is set
    inst:DoTaskInTime(0, InitializePathFinding)
	
	if not TheNet:IsDedicated() then
		inst:DoPeriodicTask(0, TrackCameraRot)
		if TheNet:GetIsServer() then
			inst:DoPeriodicTask(0, checkforfriendwalls)
		end
	else
		inst:DoTaskInTime(0, InitializeTrackCameraRotation)
		inst:DoPeriodicTask(0, checkforfriendwalls)
	end
	
    inst.OnRemoveEntity = onremove
	
	inst._hostfacing = net_ushortint(inst.GUID, "_hostfacing", "onhostchangefacing")
	
    inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
		inst._clientfacing = TheCamera:GetHeading()
		inst:ListenForEvent("onhostchangefacing", OnHostChangeFacing)
        return inst
    end
	
    inst:AddComponent("inspectable")
    inst:AddComponent("lootdropper")

	MakeMediumBurnable(inst)
	MakeLargePropagator(inst)
	inst.components.burnable.flammability = .5
	inst.components.propagator.flashpoint = 30+math.random()*10         

    inst.SoundEmitter:PlaySound("dontstarve/common/place_structure_wood")        

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(3)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit) 
	
	inst:AddComponent("zupalexsgates")
	inst.components.zupalexsgates.openfn = onopenwoodgate
	inst.components.zupalexsgates.closefn = onclosewoodgate
	
    MakeHauntableWork(inst)

    MakeSnowCovered(inst)

    return inst
end

return  Prefab("common/gates/woodgate_item", woodgateitemfn, assets, prefabs),
		Prefab("common/gates/woodgate", woodgatedeployedfn, assets, prefabs),
		MakePlacer("common/gates/woodgate_item_placer", "woodgate_closed", "gates", "placed_270", false, false, true, nil, nil, nil)